
/*
SSI Per lettura encoder assoluto HH-12 by DF1SR
IK4PMB Dec 2016
ik4pmb@ik4pmb.it
*/
/////// I/O

int clk = 12;         // OUT Clock
int cs = 11;          // OUT Data send
int data = 2;         // IN SSI

//////// Variables

byte SSI_Array[12];   // Array reseved for the recieved Gray Code
int i = 0;            // Loop index
word posizione = 0;   // Position real value
float gradi = 0;      // Position in °


void setup()

{
 pinMode(clk, OUTPUT); 
 pinMode(cs, OUTPUT);
 pinMode(data,INPUT);
 
 delay(500);
 Serial.begin(9600);  
}


void loop()
{
 SSI_READ();                    // Read SSI
 DATA_TRANSFORM();              // Transform from array to single word
 DATA_WRITE();                  // Write data via serial
 
 delay(2000);
}

////////// SSI READ

void SSI_READ()
{
 
 digitalWrite ( cs , LOW );          // Start to encoder
 delayMicroseconds(100);
 
 for(i = 0;i < 12; i++)
 {
   digitalWrite ( clk, HIGH );
   delayMicroseconds(30);
   SSI_Array[i]= digitalRead(data);  // Fill array
   digitalWrite ( clk , LOW );
   delayMicroseconds(30);  
 }
 digitalWrite ( cs , HIGH );
 delayMicroseconds(100);
 
}
//////// From array to single word

void DATA_TRANSFORM()
{
   posizione = (SSI_Array[11] + (SSI_Array[10] * 2) + (SSI_Array[9] * 4) + (SSI_Array[8] * 8));
   posizione = (posizione + (SSI_Array[7] * 16) + (SSI_Array[6] * 32) + (SSI_Array[5] * 64)); 
   posizione = (posizione + (SSI_Array[4] * 128) + (SSI_Array[3] * 256) + (SSI_Array[2] *512));
   posizione = (posizione + (SSI_Array[1] * 1024) + (SSI_Array[0] * 2048));
   
   }
/////// Data write to serial port

void  DATA_WRITE()
{
   Serial.print(posizione);
   Serial.print("  ");
   
   
   for(i = 0; i < 12; i++)
   {
     Serial.print(SSI_Array[i]);
     SSI_Array[i] = 0;
     
     
   }
   Serial.print("  ");
   gradi = (posizione / 11.375 );
   Serial.print ( gradi );
   Serial.println("  ");
}



